/*
 * Copyright 2014-2018 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.testbase.storage.internal;

import ru.ispras.fortress.util.InvariantChecks;
import ru.ispras.testbase.TestBaseQuery;
import ru.ispras.testbase.TestData;
import ru.ispras.testbase.knowledge.iterator.Iterator;
import ru.ispras.testbase.storage.DataConverter;
import ru.ispras.testbase.storage.StoredTestData;

import java.util.List;
import java.util.Map;

public class RawDataConverter implements DataConverter {
  public String getName() {
    return getClass().getName();
  }

  @SuppressWarnings("unchecked")
  public Iterator<TestData> convert(final StoredTestData data, final TestBaseQuery query) {
    InvariantChecks.checkNotNull(data);
    InvariantChecks.checkNotNull(query);

    final List<Map<String, String>> dataset = (List<Map<String, String>>) data.getData();
    return new RawDataProvider(dataset, query.getBindings());
  }
}
